routes/admin.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\Admin\HomeController;
use App\Http\Controllers\Admin\ReporteController;

Route::get('', [HomeController::class, 'index']);
// Tramo
Route::resource('/tramo', 'App\Http\Controllers\Admin\TramoController');
// Reporte
Route::get('/reporte', ReporteController::class);
//buses
Route::resource('/bus', 'App\Http\Controllers\BusController');

// viajes
Route::resource('/viajes', 'App\Http\Controllers\ViajeController');

//asientos
Route::resource('/asientos', 'App\Http\Controllers\AsientoController');

//Route::get('/bus', [BusController::class, 'index'])->name('bus');
//espacios
Route::resource('/espacios', 'App\Http\Controllers\EspacioController');
//Route::resource('/bus/crear', [BusController::class, 'create']);

routes/web.php
<?php

use App\Http\Controllers\ViajeController;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\BoletoController;
use App\Http\Controllers\PaymentController;
use App\Http\Controllers\BusController;
use App\Http\Controllers\DestinosController;
use App\Http\Controllers\PagoController;


/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
//Route::resource('buses','BusController');
Route::resource('buses', 'App\Http\Controllers\BusController');

Route::get('/', function () {
    return view('destinos.buscador');
});

Route::middleware(['auth:sanctum', 'verified'])->get('/admin', function () {
    return view('admin.index');
})->name('admin');

//           ruta    clase controlador       método
Route::get('/home', [HomeController::class, 'index'])->name('home');
//           ruta    clase controlador       método
// Route::get('admin/viajes', [ViajeController::class, 'index'])->name('viajes');
// Route::get('/viajes/crear', [ViajeController::class, 'create']);
Route::get('admin/bus', [BusController::class, 'index'])->name('bus');
Route::get('/bus/crear', [BusController::class, 'create']);
Route::get('admin/viajes', [ViajeController::class, 'index'])->name('viajes');
// Route::get('/viajes', [ViajeController::class, 'index']);
Route::get('/viajes/crear', [ViajeController::class, 'create']);

Route::get('admin/bus', [BusController::class, 'index'])->name('bus');
Route::get('/bus/crear', [BusController::class, 'create']);
// Route::get('/bus', [BusController::class, 'index'])->name('home');
Route::get('boleto/{id}', BoletoController::class);
Route::get('/cliente', function(){ return view('cliente'); });
Route::resource('/compra', 'App\Http\Controllers\CompraController');
Route::get('pago/{id}', PagoController::class);
Route::get('/paypal/pay', [PaymentController::class, 'payWithPayPal']);
Route::get('/paypal/status', [PaymentController::class, 'payPalStatus']);

// Route::get('/destinos', function(){ return view('destinos.listar'); });
Route::get('/destinos',[DestinosController::class, 'index']);


//Auth::routes();


//Route::get('/buses','BusController@listar')->name('bus');
Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

app/Models/Viaje.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Viaje extends Model
{
    use HasFactory;
    //Relación uno a muchos (Inverso)
    public function tramo(){
        return $this->belongsTo('App\Models\Tramo');
    }
    //Relación uno a muchos (Inverso)
    public function viaje(){
        return $this->belongsTo('App\Models\Viaje');
    }
    //Relación uno a muchos
    public function espacios(){
        return $this->hasMany('App\Models\Espacio');
    }
}

app/Http/Controllers/ViajeController.php
<?php

namespace App\Http\Controllers;

use App\Models\Viaje;
use Illuminate\Http\Request;
use App\Models\Tramo;
use App\Models\Bus;
use App\Models\Espacio;

class ViajeController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {

        $viajes = Viaje::all();
        foreach ($viajes as $key => $value) {
            $busActual = Bus::where('id', $value->bus_id )->first();
            $viajes[$key]["bus"] = $busActual->placa;
        }
        
        foreach ($viajes as $key => $value) {
            $tramoActual = Tramo::where('id', $value->tramo_id )->first();
            $viajes[$key]["tramo"] = $tramoActual->origen .' - '.$tramoActual->destino;
        }
        
        return view('admin.viajes.listar', [
            "viajes"=> $viajes,
        ]);

    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create(){
        $tramos = Tramo::all();
        $buses = Bus::all();
        return view('admin.viajes.crear',
            ['tramos' => $tramos],
            ['buses' => $buses]
        );
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $viaje = new Viaje();

        $viaje->hora_partida = $request->get('hora_partida');
        $viaje->fecha_partida = $request->get('fecha_partida');
        $viaje->tramo_id = $request->get('tramo_id');
        $viaje->bus_id = $request->get('bus_id');
        $viaje->precio = $request->get('precio');
        $viaje->hora_llegada = $request->get('hora_partida');
        $viaje->fecha_llegada = $request->get('fecha_partida');
        $viaje->save();
        
        $idViaje = $viaje->id;
        $idBus = $request->get('bus_id');
        $busAsientos = Bus::where('buses.id','=',$idBus)
                    ->join('asientos', 'asientos.bus_id', '=', 'buses.id')
                    ->select('asientos.id')
                    ->get();

        foreach ($busAsientos as $asiento) {
            $espacio = new Espacio();
            $espacio->estado="disponible";
            $espacio->asiento_id = $asiento->id;
            $espacio->viaje_id = $idViaje;
            $espacio->save();
        } 
        return redirect('/admin/viajes');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\Viaje  $viaje
     * @return \Illuminate\Http\Response
     */
    public function show(Viaje $viaje)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\Viaje  $viaje
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $viaje = Viaje::find($id);
        $tramos = Tramo::all();
        $buses = Bus::all();
        return view('admin.viajes.edit', )
            ->with('viaje', $viaje)
            ->with('tramos', $tramos)
            ->with('buses', $buses);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\Viaje  $viaje
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $viaje = Viaje::find($id);

        $viaje->hora_partida = $request->get('hora_partida');
        $viaje->fecha_partida = $request->get('fecha_partida');
        $viaje->tramo_id = $request->get('tramo_id');
        $viaje->bus_id = $request->get('bus_id');
        $viaje->precio = $request->get('precio');
        $viaje->save();

        return redirect('/admin/viajes');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Viaje  $viaje
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $viaje = Viaje::find($id);
        $viaje->delete();
        return redirect('/admin/viajes'); 
    }
}

resources/views/admin/viajes/crear.blade.php
@extends('adminlte::page')
@section('title', 'Añadir viaje')
@section('content')
<div>
    <div>
        <h2>REGISTRAR VIAJES</h2>
        <form class="row g-3" action="/admin/viajes" method="POST">
        @csrf
            <div class="col-md-6">
              <label for="hora" class="form-label">Hora de partida</label>
              <input type="time" name="hora_partida" class="form-control" id="hora">
            </div>
            <div class="col-md-6">
              <label for="fecha" class="form-label">Fecha de partida</label>
              <input type="date" name="fecha_partida" class="form-control" id="fecha">
            </div>
            <div class="col-md-6 my-4">
              <label for="fecha" class="form-label">Tramo</label>
              <select name="tramo_id" id="" class="p-2">
                @foreach ($tramos as $tramo)
                  <option value="{{$tramo->id}}">{{$tramo->origen}} -  {{$tramo->destino}}</option>
                @endforeach
              </select>
            </div>
            <div class="col-auto my-4">
                <label class="visually-hidden" for="nro">Placa</label>
                <select class="form-select p-2" name="bus_id" id="">
                @foreach ($buses as $bus)
                  <option value="{{$bus->id}}">{{$bus->placa}}</option>
                @endforeach
                </select>
              </div>
              <div class="col-md-6">
              <label for="precio" class="form-label">Precio</label>
              <input type="number" name="precio" class="form-control" id="precio">
            </div>
            <div class="col-12 py-4">
              <a href="/admin/viajes" class="btn btn-secondary" tabindex="3">Cancelar</a>
              <button type="submit" class="btn btn-secondary">Guardar</button>
            </div>
          </form>
    </div>
</div>
@stop

@section('css')
    <link rel="stylesheet" href="/css/admin_custom.css">
@stop

resources/views/admin/viajes/edit.blade.php
@extends('adminlte::page')
@section('title', 'Editar viaje')
@section('content')
<div>
    <div>
        <h2>EDITAR REGISTRO</h2>
        <form class="row g-3" action="/admin/viajes/{{$viaje->id}}" method="POST">
        @csrf
        @method('PUT')
            <div class="col-md-6">
              <label for="hora" class="form-label">Hora de partida</label>
              <input type="time" value="{{$viaje->hora_partida}}" name="hora_partida" class="form-control" id="hora">
            </div>
            <div class="col-md-6">
              <label for="fecha" class="form-label">Fecha de partida</label>
              <input type="date" value="{{$viaje->fecha_partida}}" name="fecha_partida" class="form-control" id="fecha">
            </div>
            <div class="col-md-6">
              <label for="fecha" class="form-label">Tramo</label>
              <select name="tramo_id" id="">
                @foreach ($tramos as $tramo)
                  <option {{ !! $tramo->id == $viaje->tramo_id ? 'selected="true"':''}}
                    value="{{$tramo->id}}">{{$tramo->origen}} -  {{$tramo->destino}}</option>
                @endforeach
              </select>
            </div>
            <div class="col-auto">
                <label class="visually-hidden" for="nro">Placa</label>
                <select class="form-select" name="bus_id">
                @foreach ($buses as $bus)
                  <option 
                    {{ !! $bus->id == $viaje->bus_id ? 'selected="true"':''}} 
                    value="{{$bus->id}}">{{$bus->placa}}</option>
                @endforeach
                </select>
              </div>
              <div class="col-md-6">
              <label for="precio" class="form-label">Precio</label>
              <input type="number" name="precio" value="{{$viaje->precio}}" class="form-control" id="precio">
            </div>
            <div class="col-12">
              <a href="/admin/viajes" class="btn btn-secondary" tabindex="3">Cancelar</a>
              <button type="submit" class="btn btn-secondary" >Guardar</button>
            </div>
          </form>
    </div>
</div>
@stop

@section('css')
    <link rel="stylesheet" href="/css/admin_custom.css">
@stop

resources/views/admin/viajes/listar.blade.php
@extends('adminlte::page')

@section('title', 'viajes')

@section('content_header')
    <h1>Viajes</h1>
@stop

@section('content')

    <a href="/admin/viajes/create" class="btn btn-primary">Registrar viajes</a>
    <table class="table table-dark table-striped mt-4">
            <thead>
              <tr>
                <th scope="col">#</th>
                <th scope="col">Hora de partida</th>
                <th scope="col">Fecha de partida</th>
                <th scope="col">Tramo</th>
                <th scope="col">Placa</th>
                <th scope="col">Precio</th>
                <th scope="col">Espacios</th>
                <th scope="col">Gestionar Viajes</th>
              </tr>
            </thead>
            <tbody>
            @foreach ($viajes as $viaje)
              <tr>
                <td>{{  $loop->index + 1 }}</td>
                <td>{{$viaje->hora_partida}}</td>
                <td>{{$viaje->fecha_partida}}</td>
                <td>{{$viaje->tramo}}</td>
                <td>{{$viaje->bus}}</td>
                <td>{{$viaje->precio}}</td>
                <td><a href="/admin/espacios?id={{$viaje->id}}" class="btn btn-info">Espacios</a></td>
                <td>
                      <form action="{{route('viajes.destroy', $viaje->id)}}" method="POST">
                        @csrf
                        @method('DELETE')
                        <a href="/admin/viajes/{{$viaje->id}}/edit" class="btn btn-info">Editar</a>
                        <button type="submit" class="btn btn-danger">Eliminar</button>
                      </form>
                </td>
              </tr>
            @endforeach
            </tbody>

          </table>
@stop

@section('css')
<link rel="stylesheet" href="/css/admin_custom.css"> 
@stop